/******************************************************************
HOS{֐@̂܂Ƃ
******************************************************************/

#include "kernel.h"
#include "kernel_id.h"
#include <stdarg.h>
#include "3052f.h"
#include "MinSys3052.h"

#define RECEIVERINGBUFFSIZE 16

static volatile int receiveptr_in;  /*input pointer for receive*/
static volatile int receiveptr_out; /*output pointer for receive*/
static unsigned char receiveringbuff[RECEIVERINGBUFFSIZE];

/* SCI */
void initSCI1(void)
{
	unsigned short int i;
	/*unsigned char dummy;*/
	SCI1.SCR.BYTE = 0;       /* clear all flags */
	                  /* 2400-38400baud are available at n=0(cks1=0,cks2=0) */
	SCI1.SMR.BYTE = 0;       /* Ascnc, 8bit , NoParity, stop1, 1/1 */
	SCI1.BRR = 19;	         /* 38400baud (CPU=25MHz) */
	for(i=0;i<60000;i++);      /* wait more than 1bit time */
	receiveptr_in=receiveptr_out=0;
	SCI1.SCR.BYTE |= 0x50;    /* scr = 0101 0000 (TIE=0,RIE=1,TE=0,RE=1) */
	SCI1.SCR.BYTE |= 0x70;    /* scr = 0111 0000 (TIE=0,RIE=1,TE=1,RE=1) */
	return;
}

/* SCIM荞 */
/*荞݂ŒڋNł͂Ȃ̂Œʏ̊֐ɂȂĂ*/
void SCI1_RXI_handler(VP_INT exinf)
{
	receiveringbuff[receiveptr_in]=SCI1.RDR;
	SCI1.SSR.BIT.RDRF = 0;
	receiveptr_in++;
	if (receiveptr_in==RECEIVERINGBUFFSIZE) receiveptr_in=0;
}

/*SCIG[֐*/
/*荞݂ŒڋNł͂Ȃ̂Œʏ̊֐ɂȂĂ*/
void SCI1_ERI_handler(VP_INT exinf)
{
	SCI1.SSR.BIT.ORER = 0; /* Overrun Error Flag Clear */
	SCI1.SSR.BIT.FER = 0;  /* Framing Error Flag Clear */
	SCI1.SSR.BIT.PER = 0;  /* Parity  Error Flag Clear */
}

/* ------------------------------------------------- */
/* GET BYTE FROM SCI1 */
/* ------------------------------------------------- */
short int getCharSCI1(void)
/* return value 0x00-0xFF:received data */
/*              -3(0xFFFE):error */
{
	int ch;
	unsigned int loop;
	loop=60000;
	while (receiveptr_out==receiveptr_in) {
		loop--;
		if (!loop) return -3;
	}
	ch=receiveringbuff[receiveptr_out];
	receiveptr_out++;
	if (receiveptr_out==RECEIVERINGBUFFSIZE) receiveptr_out=0;
	return ch;
}

/* ------------------------------------------------- */
/* CHECK SCI BUFFER AND GET DATA */
/* ------------------------------------------------- */
short int chkgetCharSCI1(void)
/* return value -1(0xFFFF):no received data  */
/*              0x00-0xFF:received data */
{
	int ch;
	unsigned int loop;
	loop=60000;
	if (receiveptr_out==receiveptr_in) {
		return -1;
	}
	ch=receiveringbuff[receiveptr_out];
	receiveptr_out++;
	if (receiveptr_out==RECEIVERINGBUFFSIZE) receiveptr_out=0;
	return ch;
}

void putStringSCI1(char *str);

/*SCI1蕶[return]I[C'\n'͎擾Ȃ*/
/*^HŃobNXyCX*/
int getStringSCI1(char *buff,int max)
{
	int i,ch;
	for (i=0;i<max-1;i++) {
		ch=getCharSCI1(); /*1擾*/
		*buff=(char)ch; /*1擾*/
		if (*buff=='\r'||ch<0) {
			*buff=0;
			return i+1;
		}
		if (*buff==0x8) {
			buff-=2;
			i-=2;
		}
		if (*buff!='\n') buff++;
		else i--;
	}
	*buff=0;
	return i+1;
}

/*SCI1փvvg\āCSCI1萮l*/
short int getIntSCI1(char prompt[])
/*getting integer from serial port*/
/* format 123[ret] */
/*        -123[ret] */
/*        0x1a[ret] */
/*        -0x100[ret] */
{
	short int x=0,y,m=0,n=0,v=0,i=0;
	char buff[16];
	putStringSCI1(prompt);
	getStringSCI1(buff,16);
	y=buff[i];
	while(y!=0){
		if(y=='-') m=1;
		if('a'<=y&&y<='z') y=y-'a'+'A';
		if(y=='0') n=1;

		if(v==1){
			if('0'<=y&&y<='9'){
				y=y-'0';
			}
			else if('A'<=y&&y<='F'){
				y=y-'A'+10;
			}
			x=16*x+y;
		}

		if(n==1&&y=='X'){
			v=1;
		}
				
		if(v==0&&'0'<=y&&y<='9'){
			y=y-'0';
			x=10*x+y;
		}

		y=buff[++i];
	}
	if(m==1) x=-x;
	return x;
}


/* ------------------------------------------------- */
/* PUT BYTE TO SCI1 */
/* ------------------------------------------------- */
void putBYTESCI1(char c)
{
	unsigned char tmp;
	do{
		tmp = SCI1.SSR.BYTE;
	} while((tmp & 0x80)==0);
	SCI1.TDR = c;
	SCI1.SSR.BIT.TDRE = 0;
	return;
}

/* ------------------------------------------------- */
/* PUT VHAR TO SCI1 */
/* ------------------------------------------------- */
void putCharSCI1(char c)
{
	unsigned char tmp;
	if (c=='\n') putCharSCI1('\r');
	do{
		tmp = SCI1.SSR.BYTE;
	} while((tmp & 0x80)==0);
	SCI1.TDR = c;
	SCI1.SSR.BIT.TDRE = 0;
	return;
}

void putStringSCI1(char *str)
{
	while(*str){
		putCharSCI1(*str);
		str++;
	}
}

/* Port3 -> LCD */
/* 7    6    5    4    3    2    1    0  */
/*          ES   RS  DB7  DB6  DB5  DB4  */

/* i/o */
#define init_LCD_Port()     P3.DDR = 0x3f
#define LCD_Port            P3.DR.BYTE
#define LCD_RegisterSelect  P3.DR.BIT.B4
#define LCD_EnableSignal    P3.DR.BIT.B5

static void LCDmsecwait(unsigned int msec)
/*mescԂȂɂȂԉ҂֐*/
{
	int i;
	long int j;
	for (i=0;i<msec;i++) {
		for (j=0;j<52000;j++);    /*52000͎ɂċ߂l*/
	}
}

static void LCDmicrosecwait(unsigned int microsec)
{/*microsecԂȂɂȂԉ҂֐*/
	int i,j;
	for (i=0;i<microsec;i++) {
		for (j=0;j<52;j++);
	}
}

static void LCDputCommand(char command) /*command width must be 4bits*/
{
	LCD_Port=(LCD_Port&0xf0)|command;
	LCD_EnableSignal=1;
	LCDmicrosecwait(5);
	LCD_EnableSignal=0;
	LCDmicrosecwait(40);
}

static void LCDputCommand2(char command2)
{
	LCDputCommand((command2>>4)&0xf);
	LCDputCommand(command2&0xf);
}

/************************************************************
LCDɌ putchar()
************************************************************/
void LCDputchar(char data)
{
	LCD_RegisterSelect=1;
	LCDputCommand((data>>4)&0xf);
	LCDputCommand(data&0xf);
	LCD_RegisterSelect=0;
}

/************************************************************
LCDɌ puts()
************************************************************/
void LCDputs(char *str)
{
	while(*str) LCDputchar(*str++);
}

/************************************************************
LCD̏
************************************************************/
void initLCD( void )
{
	init_LCD_Port();        /* output */
	LCD_Port&=0xc0;
	LCDmsecwait(30);           /* wait 30ms */
	LCDputCommand(0x3);     /* function set */
	LCDmicrosecwait(4100);
	LCDputCommand(0x3);     /* function set */
	LCDmicrosecwait(100);
	LCDputCommand(0x3);     /* function set */
	LCDmicrosecwait(100);
	LCDputCommand(0x2);     /* function set data width=4bit*/
	LCDputCommand2(0x28);   /* function set 4bit duty:1/16,size:5*7 */
	LCDputCommand2(0x0c);   /* display on,cursor off,blink off */
	LCDputCommand2(0x06);   /* address:auto increment,cursor shift:right */
	LCDputCommand2(0x01);   /* clear display */
	LCDmicrosecwait(1640);
}

/************************************************************
LCDɌ gotoxy()
************************************************************/

void LCDgotoxy(unsigned x,unsigned y)
{
	unsigned char point;
	point=0x80+x+0x40*y;
	LCDputCommand2(point);
}

/************************************************************
LCDɌ clrscr()   clear screen
************************************************************/
void LCDclrscr(void)
{
	LCDputCommand2(0x01);    /* clear display */
	LCDmicrosecwait(1640);
}

const static char hexstring[]="0123456789abcdef0123456789ABCDEF";
#define MAXDIGIT 32
const static int SCI1device=1;
const static int LCDdevice=2;

static void Device_printf(int device, char *format, va_list arg_ptr)
{
	void (*device_putchar)(char ch);
	void (*device_puts)(char *ptr);
	char buf[MAXDIGIT];
	unsigned char flag=0;  /*%d:bit2 l:bit1 %:bit0 */
	unsigned char digit=0; /*  */
	unsigned char minus=0;
	char fill=' ',format1=' ';
	unsigned char radix=10; /*Ni*/
	char sign=' ';
	char *ptr=buf; /*o͕|C^*/
	unsigned char cntr=0; /*o͕JE^*/
	unsigned char shift=0; /*16iVtg 0 or 6*/
	unsigned char i;
	unsigned long int value=0;
	if (device==SCI1device) {
		device_putchar=putCharSCI1;
		device_puts=putStringSCI1;
	} else { /*device==LCDdevice*/
		device_putchar=LCDputchar;
		device_puts=LCDputs;
	}
	/*va_start(arg_ptr,format);*/
	while (*format) {
		format1=*format;
		if (flag==0) {
			if (format1=='%') {
				flag=1;
				digit=0;
				fill=' ';
				minus=0;
				radix=0;
				ptr=&buf[MAXDIGIT-1];
				*ptr--='\0';
				cntr=0;
				shift=0;
				sign='+';
			} else {
				device_putchar(format1);
			}
		} else {
			if (format1=='l') {
				flag|=2;
			} else if ('0'<=(format1)&&(format1)<='9') {
				if (digit==0 && format1=='0') {
					fill='0';
				} else {
					digit=digit*10+((format1)-'0');
					if (MAXDIGIT-2<digit) digit=MAXDIGIT-2;
				}
			} else if (format1=='-') {
				minus=1;
			} else if (format1=='d') {
				flag|=4;
				radix=10;
			} else if (format1=='u') {
				radix=10;
			} else if (format1=='x') {
				radix=16;
			} else if (format1=='X') {
				radix=16;shift=16;
			} else if (format1=='o') {
				radix=8;
			} else if (format1=='b') {
				radix=2;
			} else if (format1=='p') {
				radix=16;shift=16;digit=8;fill='0';flag|=2;
			} else if (format1=='c') {
				device_putchar((unsigned char)(va_arg(arg_ptr,int)));
				flag=0;
			} else if (format1=='s') {
				if (digit) {
					cntr=0;ptr=va_arg(arg_ptr,char *);
					while (ptr[cntr]) cntr++; /*cntr͕*/
					if (!minus) for (i=cntr;i<digit;i++) device_putchar(' ');
					device_puts(ptr);
					if (minus) for (i=cntr;i<digit;i++) device_putchar(' ');
				} else {
					device_puts(va_arg(arg_ptr,char *));
				}
				flag=0;
			} else {
				device_putchar(format1);
				flag=0;
			}
			if (radix) {
				switch (flag&6) {
				case 0: /* unsig int */
					value=(unsigned int)va_arg(arg_ptr,int);
					break;
				case 2: /* unsig long int */
					value=va_arg(arg_ptr,long int);
					break;
				case 4: /* sig int */
					value=(long int)va_arg(arg_ptr,int);
					if ((long int)value<0) {
						value=-(long int)value;
						sign='-';
					}
					break;
				case 6: /* sig long int */
					value=va_arg(arg_ptr,long int);
					if ((long int)value<0) {
						value=-(long int)value;
						sign='-';
					}
					break;
				default:
					break;
				}
				while (value) {
					*ptr--=hexstring[value%radix+shift];
					cntr++;
					value/=radix;
				}
				if (cntr==0) {
					*ptr--='0';
					cntr++;
				}
				if (fill==' ') {
					if (sign=='-') {
						*ptr--='-';
						cntr++;
					}
					if (!minus) for (i=cntr;i<digit;i++) device_putchar(' ');
					device_puts(++ptr);
					if (minus) for (i=cntr;i<digit;i++) device_putchar(' ');
				} else {
					for (;cntr<digit-1;cntr++) *ptr--='0';
					if (sign!='-'&&cntr<digit) *ptr--='0';
					else if (sign=='-') *ptr--='-';
					device_puts(++ptr);
				}
				flag=0;
			}
		}
		format++;
	}
	/*va_end(arg_ptr);*/
}

void SCI1_printf(char *format,...)
{
	va_list arg;
	va_start(arg, format);
	Device_printf(SCI1device, format, arg);
	va_end(arg);
}

void LCD_printf(char *format,...)
{
	va_list arg;
	va_start(arg, format);
	Device_printf(LCDdevice, format, arg);
	va_end(arg);
}

/* ------------------------------------------------- */
/* LED INITIALIZATION */
/* ------------------------------------------------- */
/**********************************************************
LED 0:P5-0
LED 1:P5-1
LED 2:P5-2
LED 3:P5-3
**********************************************************/
void initLed(void)
{
	P5.DDR = 0xf;
}

/* ------------------------------------------------- */
/* LET LED ON */
/* ------------------------------------------------- */
/*number0܂1,2,3*/
void turnOnLed(short int number)
{	
	static const unsigned char mask[]={1,2,4,8};
	P5.DR.BYTE |=mask[number];
}

/* ------------------------------------------------- */
/* LET LED OFF */
/* ------------------------------------------------- */
/*number0܂1,2,3*/
void turnOffLed(short int number)
{
	static const unsigned char mask[]={0xfe,0xfd,0xfb,0xf7};
	P5.DR.BYTE &=mask[number];
}

/* ------------------------------------------------- */
/* PUSH SW INITIALIZATION */
/* ------------------------------------------------- */
/**********************************************************
{^XCb`S0FP4-4
{^XCb`S1FP4-5
{^XCb`S2FP4-6
{^XCb`S3FP4-7
**********************************************************/
void initPushSW(void)
{
	P4.DDR=0xf; /*P4-4,5,6,7͓*/
	P4.PCR.BYTE|=0xf0; /*P4-4,5,6,7̓vAbv */
}

short int checkPushSW(short int number)
/*push sw 0,1,2,3̏Ԃ𒲂ׂ@number:0,1,2,or 3*/
/*Ă1AłȂ0Ԃ*/
{
	short int ret;
	static const unsigned char mask[]={0x10,0x20,0x40,0x80};
	if (P4.DR.BYTE&mask[number]) ret=0;
	else ret=1;
	return ret;
}

unsigned char getPushSW(void)
/*{^XCb`ɑΉerbg̏ԂԂBON=1COFF=0B*/
/*{^XCb`0,1,2,30,1,2,3rbgɑΉĂ*/
{
	return (((unsigned char)(~(P4.DR.BYTE>>4)))&0xf);
}

/* ------------------------------------------------- */
/* PUSH 8 BIT SW INITIALIZATION */
/* ------------------------------------------------- */
void init8BitSW(void)
{
	P2.DDR = 0x00;/*8bitSW̃|[g͂ɐݒ*/
	P2.PCR.BYTE = 0xff;/*8bitSW̃vAbvݒ*/
}

short int check8BitSW(short int number)
/*8bitsw 0,1,2,3,4,5,6,7̏Ԃ𒲂ׂ@number:0,1,2,3,4,5,6,or 7*/
/*ONȂ1AłȂ0Ԃ*/
{
	short int ret;
	static const unsigned char mask[]={1,2,4,8,0x10,0x20,0x40,0x80};
	if (P2.DR.BYTE&mask[number]) ret=0;
	else ret=1;
	return ret;
}

unsigned char get8BitSW(void)
/*XCb`ɑΉerbg̏ԂԂBON=1COFF=0B*/
{
	return (unsigned char)(~P2.DR.BYTE);
}



static void initTimer0Int(unsigned short int period)
/*ITU0ɂ銄荞݃^C}[̐ݒ(zqN2001ɂ)*/
/*荞݊Ԋu͈peiodŒPʂ̓secł*/
/*l32767ȉłȂ΂ȂȂ*/
/*32.767msec܂*/
{
    unsigned long int prd=period;
    prd=prd*3125/2000;
    period=(unsigned int) prd;
    ITU0.TCR.BIT.CCLR=1;  /*GRÃRyA}b`TCNTNA*/
    ITU0.TCR.BIT.CKEG=0;  /*オGbWŃJEg*/
    ITU0.TCR.BIT.TPSC=3;  /*NbN/8ŃJEg*/
    ITU0.GRA=2*period-1;  /*荞݂̎period[s]Ɏw*/
    ITU0.TIER.BIT.IMIEA=1; /*TCNT=GRAƂȂƂ̊荞ݗv*/
    ITU0.TIER.BIT.OVIE=0;  /*I[o[EA_[t[̊荞݂֎~*/
    ITU0.TIER.BIT.IMIEB=0;  /*TCNT=GRBƂȂƂ̊荞݂֎~*/
}

#define startTimer0() (ITU.TSTR.BYTE |= 0x01) /* Timer CH0 X^[g */

/* OS^C}̏ */
void initSystemTimer(VP_INT exinf)
{
	initTimer0Int(1000); /*VXe^C}1msec*/
	startTimer0();
}

#define clearTimer0Flag() (ITU0.TSR.BIT.IMFA=0)
/*ITU0 荞݃[`*/
/*荞݂ŒڋNł͂Ȃ̂Œʏ̊֐ɂȂĂ*/
void SystemTimerHandler(VP_INT exinf)
{
	/* 荞ݗvNA */
	clearTimer0Flag();
	
	/* ^CeBbN */
	isig_tim();
}


void idletask(VP_INT exinf)
{
	while(1);
}

